> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Rotate Webhook Secret

> Rotates the webhook secret.

`Unary` · [`Webhooks`](/docs/api-reference/generated/webhook/overview)

Rotates the webhook secret.

Use this method to:

* Generate a new webhook secret
* Invalidate the old webhook secret

### Examples

* Rotate webhook secret:

  Generates a new webhook secret.

  ```yaml theme={null}
  webhookId: "b0e12f6c-4c67-429d-a4a6-d9838b5da047"
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.WebhookService/RotateWebhookSecret
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.WebhookService/RotateWebhookSecret" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "webhookId": "<webhook-id>"
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.webhook_pb2 as webhook_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = webhook_pb2.RotateWebhookSecretRequest(
      webhook_id="<webhook-id>",
  )
  response = ona.services.webhook.rotate_webhook_secret(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { RotateWebhookSecretRequestSchema } from "@gitpod/sdk/gitpod/v1/webhook_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(RotateWebhookSecretRequestSchema, {
      webhookId: "<webhook-id>",
    });
    const response = await ona.services.webhook.rotateWebhookSecret(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.RotateWebhookSecretRequest{
  		WebhookId: "<webhook-id>",
  	})
  	response, err := ona.Services.Webhook.RotateWebhookSecret(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "webhookId": "<webhook-id>"
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.RotateWebhookSecretRequest`

RotateWebhookSecretRequest rotates the webhook secret.

| Field       | Type   | Required | Description                      |
| ----------- | ------ | -------- | -------------------------------- |
| `webhookId` | string | No       | Constraints: `string.uuid=true`. |

## Response

`gitpod.v1.RotateWebhookSecretResponse`

| Field    | Type   | Required | Description                        |
| -------- | ------ | -------- | ---------------------------------- |
| `secret` | string | No       | The new webhook secret (decrypted) |
